## bedtools 2.27.1+dfsg

=== Makefile ===

# ==========================
# BEDTools Makefile
# (c) 2009 Aaron Quinlan
# ==========================

SHELL := /bin/bash -e

VERSION_FILE=./src/utils/version/version_git.h
RELEASED_VERSION_FILE=./src/utils/version/version_release.txt



# define our object and binary directories
export OBJ_DIR	= obj
export BIN_DIR	= bin
export SRC_DIR	= src
export UTIL_DIR	= src/utils
export CXX		= g++
ifeq ($(DEBUG),1)
export CXXFLAGS = -Wall -Wextra -DDEBUG -D_DEBUG -g -O0 -D_FILE_OFFSET_BITS=64 -fPIC $(INCLUDES)
else
export CXXFLAGS = -Wall -O2 -D_FILE_OFFSET_BITS=64 -fPIC $(INCLUDES)
endif

# If the user has specified to do so, tell the compile to use rand() (instead of mt19937).
ifeq ($(USE_RAND),1)
export CXXFLAGS += -DUSE_RAND
else
export CXXFLAGS += -std=c++11
endif 

export LIBS		= -lz
export BT_ROOT  = src/utils/BamTools/

prefix ?= /usr/local

SUBDIRS = $(SRC_DIR)/annotateBed \
		  $(SRC_DIR)/bamToBed \
		  $(SRC_DIR)/bamToFastq \
		  $(SRC_DIR)/bedToBam \
		  $(SRC_DIR)/bedpeToBam \
		  $(SRC_DIR)/bedToIgv \
		  $(SRC_DIR)/bed12ToBed6 \
		  $(SRC_DIR)/closestFile \
		  $(SRC_DIR)/clusterBed \
		  $(SRC_DIR)/complementFile \
		  $(SRC_DIR)/coverageFile \
		  $(SRC_DIR)/expand \
		  $(SRC_DIR)/fastaFromBed \
		  $(SRC_DIR)/flankBed \
		  $(SRC_DIR)/genomeCoverageBed \
		  $(SRC_DIR)/getOverlap \
		  $(SRC_DIR)/groupBy \
		  $(SRC_DIR)/intersectFile \
		  $(SRC_DIR)/fisher \
		  $(SRC_DIR)/jaccard \
		  $(SRC_DIR)/linksBed \
		  $(SRC_DIR)/maskFastaFromBed \
		  $(SRC_DIR)/mapFile \
		  $(SRC_DIR)/mergeFile \
		  $(SRC_DIR)/multiBamCov \
		  $(SRC_DIR)/multiIntersectBed \
		  $(SRC_DIR)/nucBed \
		  $(SRC_DIR)/pairToBed \
		  $(SRC_DIR)/pairToPair \
		  $(SRC_DIR)/randomBed \
		  $(SRC_DIR)/regressTest \
		  $(SRC_DIR)/reldist \
		  $(SRC_DIR)/sampleFile \
		  $(SRC_DIR)/shiftBed \
		  $(SRC_DIR)/shuffleBed \
		  $(SRC_DIR)/slopBed \
		  $(SRC_DIR)/sortBed \
		  $(SRC_DIR)/spacingFile \
		  $(SRC_DIR)/split \
		  $(SRC_DIR)/subtractFile \
		  $(SRC_DIR)/tagBam \
		  $(SRC_DIR)/unionBedGraphs \
		  $(SRC_DIR)/windowBed \
		  $(SRC_DIR)/windowMaker

UTIL_SUBDIRS =	$(SRC_DIR)/utils/FileRecordTools \
				$(SRC_DIR)/utils/FileRecordTools/FileReaders \
				$(SRC_DIR)/utils/FileRecordTools/Records \
				$(SRC_DIR)/utils/bedFile \
				$(SRC_DIR)/utils/BinTree \
				$(SRC_DIR)/utils/version \
				$(SRC_DIR)/utils/bedGraphFile \
				$(SRC_DIR)/utils/chromsweep \
				$(SRC_DIR)/utils/Contexts \
				$(SRC_DIR)/utils/general \
				$(SRC_DIR)/utils/gzstream \
				$(SRC_DIR)/utils/fileType \
				$(SRC_DIR)/utils/bedFilePE \
				$(SRC_DIR)/utils/KeyListOps \
				$(SRC_DIR)/utils/NewChromsweep \
				$(SRC_DIR)/utils/sequenceUtilities \
				$(SRC_DIR)/utils/tabFile \
				$(SRC_DIR)/utils/BamTools \
				$(SRC_DIR)/utils/BamTools-Ancillary \
				$(SRC_DIR)/utils/BlockedIntervals \
				$(SRC_DIR)/utils/Fasta \
				$(SRC_DIR)/utils/VectorOps \
				$(SRC_DIR)/utils/GenomeFile \
				$(SRC_DIR)/utils/RecordOutputMgr \
				$(SRC_DIR)/utils/ToolBase \
				$(SRC_DIR)/utils/driver

BUILT_OBJECTS = $(OBJ_DIR)/*.o


INCLUDES =	-I$(SRC_DIR)/utils/bedFile \
				-I$(SRC_DIR)/utils/BinTree \
				-I$(SRC_DIR)/utils/version \
				-I$(SRC_DIR)/utils/bedGraphFile \
				-I$(SRC_DIR)/utils/chromsweep \
				-I$(SRC_DIR)/utils/Contexts \
				-I$(SRC_DIR)/utils/FileRecordTools \
				-I$(SRC_DIR)/utils/FileRecordTools/FileReaders \
				-I$(SRC_DIR)/utils/FileRecordTools/Records \
				-I$(SRC_DIR)/utils/general \
				-I$(SRC_DIR)/utils/gzstream \
				-I$(SRC_DIR)/utils/fileType \
				-I$(SRC_DIR)/utils/gzstream/ \
				-I$(SRC_DIR)/utils/lineFileUtilities \
				-I$(SRC_DIR)/utils/KeyListOps \
				-I$(SRC_DIR)/utils/NewChromsweep \
				-I$(SRC_DIR)/utils/sequenceUtilities \
				-I$(SRC_DIR)/utils/tabFile \
				-I$(SRC_DIR)/utils/BamTools \
				-I$(SRC_DIR)/utils/BamTools/include \
				-I$(SRC_DIR)/utils/BamTools/src \
				-I$(SRC_DIR)/utils/BamTools-Ancillary \
				-I$(SRC_DIR)/utils/BlockedIntervals \
				-I$(SRC_DIR)/utils/Fasta \
				-I$(SRC_DIR)/utils/VectorOps \
				-I$(SRC_DIR)/utils/GenomeFile \
				-I$(SRC_DIR)/utils/RecordOutputMgr \
				-I$(SRC_DIR)/utils/ToolBase \
				-I$(SRC_DIR)/utils/driver \


all: print_banner $(OBJ_DIR) $(BIN_DIR) autoversion $(UTIL_SUBDIRS) $(SUBDIRS)
	@echo "- Building main bedtools binary."
	@$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c src/bedtools.cpp -o obj/bedtools.o $(INCLUDES)
	@$(CXX) $(CXXFLAGS) $(CPPFLAGS) -o $(BIN_DIR)/bedtools $(BUILT_OBJECTS) -L$(UTIL_DIR)/BamTools/lib/ -lbamtools $(LIBS) $(LDFLAGS) $(INCLUDES)
	@echo "done."

	@echo "- Creating executables for old CLI."
	@python scripts/makeBashScripts.py
	@chmod +x bin/*
	@echo "done."


.PHONY: all

install: all
	mkdir -p $(DESTDIR)$(prefix)/bin
	for file in bin/* ; do \
		cp -f $$file $(DESTDIR)$(prefix)/bin; \
	done

print_banner:
	@echo "Building BEDTools:"
	@echo "========================================================="
	$(info $$CXXFLAGS is [${CXXFLAGS}])
.PHONY: print_banner

# make the "obj/" and "bin/" directories, if they don't exist
$(OBJ_DIR) $(BIN_DIR):
	@mkdir -p $@


# One special case: All (or almost all) programs requires the BamTools API files to be created first.
.PHONY: bamtools_api
bamtools_api:
	@$(MAKE) --no-print-directory --directory=$(BT_ROOT) api
$(UTIL_SUBDIRS) $(SUBDIRS): bamtools_api


# even though these are real directories, treat them as phony targets, forcing to always go in them are re-make.
# a future improvement would be the check for the compiled object, and rebuild only if the source code is newer.
.PHONY: $(UTIL_SUBDIRS) $(SUBDIRS)
$(UTIL_SUBDIRS) $(SUBDIRS): $(OBJ_DIR) $(BIN_DIR)
	@echo "- Building in $@"
	@$(MAKE) --no-print-directory --directory=$@

clean:
	@$(MAKE) --no-print-directory --directory=$(BT_ROOT) clean_api
	@echo " * Cleaning up."
	@rm -f $(VERSION_FILE) $(OBJ_DIR)/* $(BIN_DIR)/*
.PHONY: clean

test: all
	@cd test; bash test.sh

.PHONY: test


## For BEDTools developers (not users):
## When you want to release (and tag) a new version, run:
##   $ make setversion VERSION=v2.17.2
## This will:
##   1. Update the "/src/utils/version/version_release.txt" file
##   2. Commit the file
##   3. Git-Tag the commit with the latest version
##
.PHONY: setversion
setversion:
    ifeq "$(VERSION)" ""
		$(error please set VERSION variable to the new version (e.g "make setversion VERSION=v2.17.2"))
    endif
		@echo "# This file was auto-generated by running \"make setversion VERSION=$(VERSION)\"" > "$(RELEASED_VERSION_FILE)"
		@echo "# on $$(date) ." >> "$(RELEASED_VERSION_FILE)"
		@echo "# Please do not edit or commit this file manually." >> "$(RELEASED_VERSION_FILE)"
		@echo "#" >> "$(RELEASED_VERSION_FILE)"
		@echo "$(VERSION)" >> $(RELEASED_VERSION_FILE)
		@git add $(RELEASED_VERSION_FILE)
		@git commit -q -m "Setting Release-Version $(VERSION)"
		@git tag "$(VERSION)"
		@echo "Version updated to $(VERSION)."
		@echo ""
		@echo "Don't forget to push the commits AND the tags:"
		@echo "  git push --all --tags"
		@echo ""


## Automatic version detection
##
## What's going on here?
## 1. If there's a ".git" repository - use the version from the repository.
##    ignore any released-version file. git repository is authorative.
##
## 2, If there's no ".git" repository,
##    get the "released" version number from the release-version file.
##
##    2.1. If the current directory looks like "arq5x-bedtools-XXXXXXX",
##         assume "-XXXXXX" is the last revision number (and the user
##         probably downloaded the ZIP from github).
##         Append the revision number to the released version string.
##
## 3. Compare the detected version (from steps 1,2) to the current string
##    in ./src/utils/version/version_git.h .
##    If they differ, update the header file - will cause a recompilation
##    of version.o .
##
.PHONY: autoversion
autoversion:
	@( \
	if [ -d ".git" ] && which git > /dev/null ; then \
		DETECTED_VERSION=$$(git describe --always --tags --dirty) ; \
	else \
		DETECTED_VERSION=$$(grep -v "^#" "$(RELEASED_VERSION_FILE)") ; \
		if basename $$(pwd) | grep -q "^[[:alnum:]]*-bedtools-[[:alnum:]]*$$" ; then \
			DETECTED_VERSION=$${DETECTED_VERSION}-zip-$$(basename "$$(pwd)" | sed 's/^[[:alnum:]]*-bedtools-//') ; \
		fi ; \
	fi ; \
	\
	CURRENT_VERSION="" ; \
	[ -e "$(VERSION_FILE)" ] && CURRENT_VERSION=$$(grep "define VERSION_GIT " "$(VERSION_FILE)" | cut -f3 -d" " | sed 's/"//g') ; \
	\
	echo "DETECTED_VERSION = $$DETECTED_VERSION" ; \
	echo "CURRENT_VERSION  = $$CURRENT_VERSION" ; \
	if [ "$${DETECTED_VERSION}" != "$${CURRENT_VERSION}" ] ; then \
		echo "Updating version file." ; \
		echo "#ifndef VERSION_GIT_H" > $(VERSION_FILE) ; \
		echo "#define VERSION_GIT_H" >> $(VERSION_FILE) ; \
		echo "#define VERSION_GIT \"$${DETECTED_VERSION}\"" >> $(VERSION_FILE) ; \
		echo "#endif /* VERSION_GIT_H */" >> $(VERSION_FILE) ; \
	fi )

=== src/bedToBam/Makefile ===
UTILITIES_DIR = ../utils/
OBJ_DIR = ../../obj/
BIN_DIR = ../../bin/

# -------------------
# define our includes
# -------------------
INCLUDES = -I$(UTILITIES_DIR)/bedFile/ \
           -I$(UTILITIES_DIR)/version/ \
           -I$(UTILITIES_DIR)/gzstream/ \
           -I$(UTILITIES_DIR)/GenomeFile/ \
           -I$(UTILITIES_DIR)/lineFileUtilities/ \
           -I$(UTILITIES_DIR)/fileType/ \
           -I$(UTILITIES_DIR)/BamTools/include \
		   -I$(UTILITIES_DIR)/BamTools-Ancillary \
		   -I$(UTILITIES_DIR)/version/

# ----------------------------------
# define our source and object files
# ----------------------------------
SOURCES= bedToBam.cpp
OBJECTS= bedToBam.o
BUILT_OBJECTS= $(patsubst %,$(OBJ_DIR)/%,$(OBJECTS))
PROGRAM= bedToBam


all: $(BUILT_OBJECTS)

.PHONY: all

$(BUILT_OBJECTS): $(SOURCES)
	@echo "  * compiling" $(*F).cpp
	@$(CXX) -c -o $@ $(*F).cpp $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS) $(INCLUDES)

clean:
	@echo "Cleaning up."
	@rm -f $(OBJ_DIR)/bedToBam.o

.PHONY: clean

=== src/closestFile/Makefile ===
UTILITIES_DIR = ../utils/
OBJ_DIR = ../../obj/
BIN_DIR = ../../bin/
TOOL_DIR = ../../src/

# -------------------
# define our includes
# -------------------
INCLUDES = -I$(UTILITIES_DIR)/Contexts/ \
			-I$(UTILITIES_DIR)/general/ \
			-I$(UTILITIES_DIR)/fileType/ \
			-I$(UTILITIES_DIR)/lineFileUtilities/ \
			-I$(UTILITIES_DIR)/gzstream/ \
           -I$(UTILITIES_DIR)/GenomeFile/ \
           -I$(UTILITIES_DIR)/BamTools/include \
           -I$(UTILITIES_DIR)/BamTools/src \
           -I$(UTILITIES_DIR)/BlockedIntervals \
           -I$(UTILITIES_DIR)/BamTools-Ancillary \
           -I$(UTILITIES_DIR)/FileRecordTools/ \
           -I$(UTILITIES_DIR)/FileRecordTools/FileReaders/ \
           -I$(UTILITIES_DIR)/FileRecordTools/Records/ \
			-I$(UTILITIES_DIR)/KeyListOps/ \
           -I$(UTILITIES_DIR)/RecordOutputMgr/ \
           -I$(UTILITIES_DIR)/NewChromsweep \
           -I$(UTILITIES_DIR)/BinTree \
           -I$(UTILITIES_DIR)/version/ \
          -I$(UTILITIES_DIR)/ToolBase/ \
           -I$(TOOL_DIR)/intersectFile/

# ----------------------------------
# define our source and object files
# ----------------------------------
SOURCES= closestHelp.cpp closestFile.cpp closestFile.h
OBJECTS= closestHelp.o closestFile.o
BUILT_OBJECTS= $(patsubst %,$(OBJ_DIR)/%,$(OBJECTS))

all: $(BUILT_OBJECTS)

.PHONY: all

$(BUILT_OBJECTS): $(SOURCES)
	@echo "  * compiling" $(*F).cpp
	@$(CXX) -c -o $@ $(*F).cpp $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS) $(INCLUDES)

clean:
	@echo "Cleaning up."
	@rm -f $(OBJ_DIR)/closestHelp.o  $(OBJ_DIR)/closestFile.o
	
.PHONY: clean

=== src/coverageFile/Makefile ===
UTILITIES_DIR = ../utils/
OBJ_DIR = ../../obj/
BIN_DIR = ../../bin/
TOOL_DIR = ../../src/

INCLUDES = -I$(UTILITIES_DIR)/Contexts/ \
			-I$(UTILITIES_DIR)/general/ \
			-I$(UTILITIES_DIR)/fileType/ \
			-I$(UTILITIES_DIR)/lineFileUtilities/ \
			-I$(UTILITIES_DIR)/gzstream/ \
           -I$(UTILITIES_DIR)/GenomeFile/ \
           -I$(UTILITIES_DIR)/BamTools/include \
           -I$(UTILITIES_DIR)/BamTools/src \
           -I$(UTILITIES_DIR)/BlockedIntervals \
           -I$(UTILITIES_DIR)/BamTools-Ancillary \
           -I$(UTILITIES_DIR)/FileRecordTools/ \
           -I$(UTILITIES_DIR)/FileRecordTools/FileReaders/ \
           -I$(UTILITIES_DIR)/FileRecordTools/Records/ \
           -I$(UTILITIES_DIR)/RecordOutputMgr/ \
			-I$(UTILITIES_DIR)/KeyListOps/ \
           -I$(UTILITIES_DIR)/NewChromsweep \
           -I$(UTILITIES_DIR)/VectorOps \
           -I$(UTILITIES_DIR)/BinTree \
           -I$(UTILITIES_DIR)/version/ \
           -I$(UTILITIES_DIR)/ToolBase/ \
           -I$(TOOL_DIR)/intersectFile/

# ----------------------------------
# define our source and object files
# ----------------------------------
SOURCES= coverageHelp.cpp coverageFile.cpp coverageFile.h
OBJECTS= coverageHelp.o coverageFile.o
BUILT_OBJECTS= $(patsubst %,$(OBJ_DIR)/%,$(OBJECTS))

all: $(BUILT_OBJECTS)

.PHONY: all

$(BUILT_OBJECTS): $(SOURCES)
	@echo "  * compiling" $(*F).cpp
	@$(CXX) -c -o $@ $(*F).cpp $(LDFLAGS) $(CXXFLAGS) $(DFLAGS) $(INCLUDES)

clean:
	@echo "Cleaning up."
	@rm -f $(OBJ_DIR)/coverageHelp.o $(OBJ_DIR)/coverageFile.o

.PHONY: clean

=== src/fisher/Makefile ===
UTILITIES_DIR = ../utils/
OBJ_DIR = ../../obj/
BIN_DIR = ../../bin/
TOOL_DIR = ../../src/

# -------------------
# define our includes
# -------------------

INCLUDES = -I$(UTILITIES_DIR)/bedFile/ \
			-I$(UTILITIES_DIR)/Contexts/ \
			-I$(UTILITIES_DIR)/general/ \
			-I$(UTILITIES_DIR)/fileType/ \
		    -I$(UTILITIES_DIR)/gzstream/ \
		   -I$(UTILITIES_DIR)/bedFile/ \
		   -I$(UTILITIES_DIR)/bedFilePE/ \
		   -I$(UTILITIES_DIR)/GenomeFile/ \
		   -I$(UTILITIES_DIR)/lineFileUtilities/ \
           -I$(UTILITIES_DIR)/BamTools/include \
           -I$(UTILITIES_DIR)/BamTools/src \
           -I$(UTILITIES_DIR)/BlockedIntervals \
           -I$(UTILITIES_DIR)/BamTools-Ancillary \
           -I$(UTILITIES_DIR)/FileRecordTools/ \
           -I$(UTILITIES_DIR)/FileRecordTools/FileReaders/ \
           -I$(UTILITIES_DIR)/FileRecordTools/Records/ \
           -I$(UTILITIES_DIR)/RecordOutputMgr/ \
			-I$(UTILITIES_DIR)/KeyListOps/ \
           -I$(UTILITIES_DIR)/NewChromsweep \
           -I$(UTILITIES_DIR)/VectorOps \
 		   -I . \
           -I$(UTILITIES_DIR)/BinTree \
           -I$(UTILITIES_DIR)/version/ \
           -I$(UTILITIES_DIR)/ToolBase/ \
           -I$(TOOL_DIR)/intersectFile/ \
           -I$(TOOL_DIR)/jaccard/
            

# ----------------------------------
# define our source and object files
# ----------------------------------
SOURCES= fisherHelp.cpp fisher.cpp fisher.h kfunc.cpp \
		 ../utils/Contexts/ContextFisher.cpp \
		 ../utils/Contexts/ContextFisher.h
OBJECTS= fisherHelp.o fisher.o kfunc.o
BUILT_OBJECTS= $(patsubst %,$(OBJ_DIR)/%,$(OBJECTS))
PROGRAM= Fisher

all: $(BUILT_OBJECTS)

.PHONY: all

$(BUILT_OBJECTS): $(SOURCES)
	@echo "  * compiling" $(*F).cpp
	@$(CXX) -c -o $@ $(*F).cpp $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS) $(DFLAGS) $(INCLUDES)
	
clean:
	@echo "Cleaning up."
	@rm -f $(OBJ_DIR)/fisherHelp.o $(OBJ_DIR)/fisher.o $(OBJ_DIR)/kfunc.o

.PHONY: clean

=== src/getOverlap/Makefile ===
UTILITIES_DIR = ../utils/
OBJ_DIR = ../../obj/
BIN_DIR = ../../bin/


# -------------------
# define our includes
# -------------------
INCLUDES = -I$(UTILITIES_DIR)/bedFile/ \
           -I$(UTILITIES_DIR)/lineFileUtilities/ \
           -I$(UTILITIES_DIR)/gzstream/ \
           -I$(UTILITIES_DIR)/fileType/ \
           -I$(UTILITIES_DIR)/version/

# ----------------------------------
# define our source and object files
# ----------------------------------
SOURCES= getOverlap.cpp
OBJECTS= getOverlap.o
BUILT_OBJECTS= $(patsubst %,$(OBJ_DIR)/%,$(OBJECTS))


all: $(BUILT_OBJECTS)

.PHONY: all

$(BUILT_OBJECTS): $(SOURCES)
	@echo "  * compiling" $(*F).cpp
	@$(CXX) -c -o $@ $(*F).cpp $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS) $(INCLUDES)

	
clean:
	@echo "Cleaning up."
	@rm -f $(OBJ_DIR)/getOverlap.o

.PHONY: clean

=== src/groupBy/Makefile ===
UTILITIES_DIR = ../utils/
OBJ_DIR = ../../obj/
BIN_DIR = ../../bin/
TOOL_DIR = ../../src/

# -------------------
# define our includes
# -------------------
INCLUDES = -I$(UTILITIES_DIR)/Contexts/ \
			-I$(UTILITIES_DIR)/general/ \
			-I$(UTILITIES_DIR)/fileType/ \
			-I$(UTILITIES_DIR)/lineFileUtilities/ \
			-I$(UTILITIES_DIR)/stringUtilities/ \
			-I$(UTILITIES_DIR)/gzstream/ \
           -I$(UTILITIES_DIR)/GenomeFile/ \
           -I$(UTILITIES_DIR)/BamTools/include \
           -I$(UTILITIES_DIR)/BamTools/src \
           -I$(UTILITIES_DIR)/BlockedIntervals \
           -I$(UTILITIES_DIR)/BamTools-Ancillary \
           -I$(UTILITIES_DIR)/FileRecordTools/ \
           -I$(UTILITIES_DIR)/FileRecordTools/FileReaders/ \
           -I$(UTILITIES_DIR)/FileRecordTools/Records/ \
			-I$(UTILITIES_DIR)/KeyListOps/ \
           -I$(UTILITIES_DIR)/RecordOutputMgr/ \
           -I$(UTILITIES_DIR)/NewChromsweep \
           -I$(UTILITIES_DIR)/BinTree \
           -I$(UTILITIES_DIR)/version/ \
           -I$(UTILITIES_DIR)/ToolBase/ \
           -I$(TOOL_DIR)/intersectFile/


# ----------------------------------
# define our source and object files
# ----------------------------------
SOURCES= groupByHelp.cpp groupBy.cpp groupBy.h
OBJECTS= groupBy.o groupByHelp.o
BUILT_OBJECTS= $(patsubst %,$(OBJ_DIR)/%,$(OBJECTS))
PROGRAM= groupBy

all: $(BUILT_OBJECTS)

.PHONY: all

$(BUILT_OBJECTS): $(SOURCES)
	@echo "  * compiling" $(*F).cpp
	@$(CXX) -c -o $@ $(*F).cpp $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS) $(INCLUDES)
	
clean:
	@echo "Cleaning up."
	@rm -f $(OBJ_DIR)/groupBy.o $(OBJ_DIR)/groupBy.o

.PHONY: clean

=== src/jaccard/Makefile ===
UTILITIES_DIR = ../utils/
OBJ_DIR = ../../obj/
BIN_DIR = ../../bin/
TOOL_DIR = ../../src/

# -------------------
# define our includes
# -------------------

INCLUDES = -I$(UTILITIES_DIR)/Contexts/ \
			-I$(UTILITIES_DIR)/general/ \
			-I$(UTILITIES_DIR)/fileType/ \
			-I$(UTILITIES_DIR)/lineFileUtilities/ \
			-I$(UTILITIES_DIR)/gzstream/ \
           -I$(UTILITIES_DIR)/GenomeFile/ \
           -I$(UTILITIES_DIR)/BamTools/include \
           -I$(UTILITIES_DIR)/BamTools/src \
           -I$(UTILITIES_DIR)/BlockedIntervals \
           -I$(UTILITIES_DIR)/BamTools-Ancillary \
           -I$(UTILITIES_DIR)/FileRecordTools/ \
           -I$(UTILITIES_DIR)/FileRecordTools/FileReaders/ \
           -I$(UTILITIES_DIR)/FileRecordTools/Records/ \
           -I$(UTILITIES_DIR)/RecordOutputMgr/ \
			-I$(UTILITIES_DIR)/KeyListOps/ \
           -I$(UTILITIES_DIR)/NewChromsweep \
           -I$(UTILITIES_DIR)/VectorOps \
           -I$(UTILITIES_DIR)/BinTree \
           -I$(UTILITIES_DIR)/version/ \
           -I$(UTILITIES_DIR)/ToolBase/ \
           -I$(TOOL_DIR)/intersectFile/

# ----------------------------------
# define our source and object files
# ----------------------------------
SOURCES= jaccardHelp.cpp jaccard.cpp jaccard.h
OBJECTS= jaccardHelp.o jaccard.o
BUILT_OBJECTS= $(patsubst %,$(OBJ_DIR)/%,$(OBJECTS))
PROGRAM= Jaccard

all: $(BUILT_OBJECTS)

.PHONY: all

$(BUILT_OBJECTS): $(SOURCES)
	@echo "  * compiling" $(*F).cpp
	@$(CXX) -c -o $@ $(*F).cpp $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS) $(DFLAGS) $(INCLUDES)
	
clean:
	@echo "Cleaning up."
	@rm -f $(OBJ_DIR)/jaccardHelp.o $(OBJ_DIR)/jaccard.o

.PHONY: clean

=== src/mapFile/Makefile ===
UTILITIES_DIR = ../utils/
OBJ_DIR = ../../obj/
BIN_DIR = ../../bin/
TOOL_DIR = ../../src/

INCLUDES = -I$(UTILITIES_DIR)/Contexts/ \
			-I$(UTILITIES_DIR)/general/ \
			-I$(UTILITIES_DIR)/fileType/ \
			-I$(UTILITIES_DIR)/lineFileUtilities/ \
			-I$(UTILITIES_DIR)/gzstream/ \
           -I$(UTILITIES_DIR)/GenomeFile/ \
           -I$(UTILITIES_DIR)/BamTools/include \
           -I$(UTILITIES_DIR)/BamTools/src \
           -I$(UTILITIES_DIR)/BlockedIntervals \
           -I$(UTILITIES_DIR)/BamTools-Ancillary \
           -I$(UTILITIES_DIR)/FileRecordTools/ \
           -I$(UTILITIES_DIR)/FileRecordTools/FileReaders/ \
           -I$(UTILITIES_DIR)/FileRecordTools/Records/ \
           -I$(UTILITIES_DIR)/RecordOutputMgr/ \
			-I$(UTILITIES_DIR)/KeyListOps/ \
           -I$(UTILITIES_DIR)/NewChromsweep \
           -I$(UTILITIES_DIR)/VectorOps \
           -I$(UTILITIES_DIR)/BinTree \
           -I$(UTILITIES_DIR)/version/ \
           -I$(UTILITIES_DIR)/ToolBase/ \
           -I$(TOOL_DIR)/intersectFile/

# ----------------------------------
# define our source and object files
# ----------------------------------
SOURCES= mapHelp.cpp mapFile.cpp mapFile.h
OBJECTS= mapHelp.o mapFile.o
BUILT_OBJECTS= $(patsubst %,$(OBJ_DIR)/%,$(OBJECTS))

all: $(BUILT_OBJECTS)

.PHONY: all

$(BUILT_OBJECTS): $(SOURCES)
	@echo "  * compiling" $(*F).cpp
	@$(CXX) -c -o $@ $(*F).cpp $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS) $(DFLAGS) $(INCLUDES)

clean:
	@echo "Cleaning up."
	@rm -f $(OBJ_DIR)/mapHelp.o $(OBJ_DIR)/mapFile.o

.PHONY: clean

=== src/maskFastaFromBed/Makefile ===
UTILITIES_DIR = ../utils/
OBJ_DIR = ../../obj/
BIN_DIR = ../../bin/

# -------------------
# define our includes
# -------------------
INCLUDES = -I$(UTILITIES_DIR)/bedFile/ \
           -I$(UTILITIES_DIR)/sequenceUtilities/ \
           -I$(UTILITIES_DIR)/lineFileUtilities/ \
           -I$(UTILITIES_DIR)/gzstream/ \
           -I$(UTILITIES_DIR)/fileType/ \
           -I$(UTILITIES_DIR)/Fasta/ \
           -I$(UTILITIES_DIR)/version/

# ----------------------------------
# define our source and object files
# ----------------------------------
SOURCES= maskFastaFromBedMain.cpp maskFastaFromBed.cpp maskFastaFromBed.h
OBJECTS= maskFastaFromBedMain.o maskFastaFromBed.o
BUILT_OBJECTS= $(patsubst %,$(OBJ_DIR)/%,$(OBJECTS))

all: $(BUILT_OBJECTS)

.PHONY: all

$(BUILT_OBJECTS): $(SOURCES)
	@echo "  * compiling" $(*F).cpp
	@$(CXX) -c -o $@ $(*F).cpp $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS) $(INCLUDES)

clean:
	@echo "Cleaning up."
	@rm -f $(OBJ_DIR)/maskFastaFromBedMain.o $(OBJ_DIR)/maskFastaFromBed.o

.PHONY: clean

=== src/pairToBed/Makefile ===
UTILITIES_DIR = ../utils/
OBJ_DIR = ../../obj/
BIN_DIR = ../../bin/

# -------------------
# define our includes
# -------------------
INCLUDES = -I$(UTILITIES_DIR)/bedFilePE/ \
            -I$(UTILITIES_DIR)/bedFile/ \
            -I$(UTILITIES_DIR)/lineFileUtilities/ \
            -I$(UTILITIES_DIR)/gzstream/ \
            -I$(UTILITIES_DIR)/fileType/ \
            -I$(UTILITIES_DIR)/BamTools/include \
            -I$(UTILITIES_DIR)/BamTools-Ancillary \
            -I$(UTILITIES_DIR)/version/

# ----------------------------------
# define our source and object files
# ----------------------------------
SOURCES= pairToBedMain.cpp pairToBed.cpp pairToBed.h
OBJECTS= pairToBedMain.o pairToBed.o
BUILT_OBJECTS= $(patsubst %,$(OBJ_DIR)/%,$(OBJECTS))

all: $(BUILT_OBJECTS)

.PHONY: all

$(BUILT_OBJECTS): $(SOURCES)
	@echo "  * compiling" $(*F).cpp
	@$(CXX) -c -o $@ $(*F).cpp $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS) $(INCLUDES)

clean:
	@echo "Cleaning up."
	@rm -f $(OBJ_DIR)/pairToBedMain.o $(OBJ_DIR)/pairToBed.o

.PHONY: clean

=== src/pairToPair/Makefile ===
UTILITIES_DIR = ../utils/
OBJ_DIR = ../../obj/
BIN_DIR = ../../bin/

# -------------------
# define our includes
# -------------------
INCLUDES = -I$(UTILITIES_DIR)/bedFilePE/ \
           -I$(UTILITIES_DIR)/bedFile/ \
           -I$(UTILITIES_DIR)/lineFileUtilities/ \
           -I$(UTILITIES_DIR)/gzstream/ \
           -I$(UTILITIES_DIR)/version/ \
           -I$(UTILITIES_DIR)/fileType/ \
           -I$(UTILITIES_DIR)/version/

# ----------------------------------
# define our source and object files
# ----------------------------------
SOURCES= pairToPairMain.cpp pairToPair.cpp pairToPair.h
OBJECTS= pairToPairMain.o pairToPair.o
BUILT_OBJECTS= $(patsubst %,$(OBJ_DIR)/%,$(OBJECTS))


all: $(BUILT_OBJECTS)

.PHONY: all

$(BUILT_OBJECTS): $(SOURCES)
	@echo "  * compiling" $(*F).cpp
	@$(CXX) -c -o $@ $(*F).cpp $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS) $(INCLUDES)


clean:
	@echo "Cleaning up."
	@rm -f $(OBJ_DIR)/pairToPairMain.o $(OBJ_DIR)/pairToPair.o

.PHONY: clean

=== debian/changelog ===
bedtools (2.27.1+dfsg-4ubuntu1) focal; urgency=medium

  * Build using python2.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 02 Apr 2020 11:32:09 +0200

bedtools (2.27.1+dfsg-4) unstable; urgency=medium

  * Disable the shuffle test on other 32-bit architectures.
  * Restrict build to little-endian release architectures. Closes: #890117
  * QA-build with Salsa.

 -- Charles Plessy <plessy@debian.org>  Thu, 14 Feb 2019 22:11:21 +0900

bedtools (2.27.1+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Print compilation commands
  * For *i386: use -ffloat-store; disable shuffle tests. Closes: #890116
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target
  * Remove trailing whitespace in debian/changelog
  * Remove trailing whitespace in debian/copyright
  * mark bedtools-test as Multi-Arch: foreign

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 04 Feb 2019 05:33:48 -0800

bedtools (2.27.1+dfsg-2) unstable; urgency=medium

  * Team upload

  [ Andreas Tille ]
  * Install autopkgtest script as /usr/share/doc/bedtools/run-unit-test
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.4
  * Drop useless get-orig-source target

  [ Liubov Chuprikova ]
  * Fix "autopkgtest fails while it succeeded in the past"
    updated run-unit-test to match new upstream tests
    Closes: #894781

 -- Liubov Chuprikova <chuprikovalv@gmail.com>  Tue, 22 May 2018 21:31:56 +0200

bedtools (2.27.1+dfsg-1) unstable; urgency=medium

  * New upstream version
  * cme fix dpkg-control
  * debhelper 11
  * d/rules: do not parse d/changelog

 -- Andreas Tille <tille@debian.org>  Sat, 10 Feb 2018 10:54:56 +0100

=== debian/control ===
Source: bedtools
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               python2,
               zlib1g-dev,
               samtools
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/med-team/bedtools
Vcs-Git: https://salsa.debian.org/med-team/bedtools.git
Homepage: https://github.com/arq5x/bedtools2

Package: bedtools
Architecture: amd64 arm64 armel armhf i386 mips64el mipsel ppc64el
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: filo
Provides: filo
Replaces: filo
Description: suite of utilities for comparing genomic features
 The BEDTools utilities allow one to address common genomics tasks such as
 finding feature overlaps and computing coverage. The utilities are largely
 based on four widely-used file formats: BED, GFF/GTF, VCF, and SAM/BAM. Using
 BEDTools, one can develop sophisticated pipelines that answer complicated
 research questions by streaming several BEDTools together.
 .
 The groupBy utility is distributed in the filo package.

Package: bedtools-test
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: bedtools
Breaks: bedtools (<< 2.19.1-1)
Replaces: bedtools (<< 2.19.1-1)
Description: test data for the bedtools package
 Test data for the BEDTools suite of utilities for comparing genomic features.
 It is distributed in a separate package because it is large and
 architecture-independent.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk
ifneq (,$(filter $(DEB_HOST_ARCH),i386 kfreebsd-i386 hurd-i386))
  export DEB_CXXFLAGS_MAINT_APPEND=-ffloat-store
endif

%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs RELEASE_HISTORY

override_dh_install:
	dh_install
	# make sure all *.sh files are featuring a '#!/bin/bash' as first line
	# since there are at least two files (test/intersect/{new_test-intersect.sh,performanceTest.sh}
	# requiring bash this is taken for all scripts instead of checking first via /bin/sh -n
	for sh in `find $(CURDIR)/debian -name "*.sh"` ; do \
	    if ! head -n1 $${sh} | grep -q '^#! */bin/[ba]*sh' ; then \
	        sed -i '1 i #!/bin/bash' $${sh} ; \
	    fi ; \
	done

override_dh_install-indep:
	# Somehow the test dir is differently named than the script has it
	# Since I fail to see how this test dir was to the script at all I
	# simply change the script afterwards
	sed -i 's/^cd groupby;/cd groupBy;/' debian/$(DEB_SOURCE)-test/usr/share/$(DEB_SOURCE)/test/test.sh

override_dh_fixperms-arch:
	dh_fixperms
	chmod -x $(CURDIR)/debian/$(DEB_SOURCE)/usr/share/bedtools/genomes/*.genome
	find $(CURDIR)/debian -name "*.bed" -executable -exec chmod -x \{\} \;
	find $(CURDIR)/debian -name "*.sh"  -not -executable -exec chmod +x \{\} \;

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifneq (,$(filter $(DEB_HOST_ARCH),i386 kfreebsd-i386 hurd-i386 armel armhf mipsel))
	mv test/shuffle debian/
endif
	dh_auto_test
ifneq (,$(filter $(DEB_HOST_ARCH),i386 kfreebsd-i386 hurd-i386 armel armhf mipsel))
	mv debian/shuffle test/
endif
endif

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, samtools, tabix
Restrictions: allow-stderr

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://github.com/arq5x/bedtools2/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## bedtools 2.29.2+dfsg

=== Makefile ===
--- 
+++ 
@@ -10,28 +10,36 @@
 RELEASED_VERSION_FILE=./src/utils/version/version_release.txt
 
 
-
 # define our object and binary directories
-export OBJ_DIR	= obj
-export BIN_DIR	= bin
-export SRC_DIR	= src
-export UTIL_DIR	= src/utils
-export CXX		= g++
+ifeq ($(VERBOSE),1)
+CCPREFIX =
+else
+CCPREFIX = @
+endif
+
+OBJ_DIR	= obj
+BIN_DIR	= bin
+SRC_DIR	= src
+
+CXX     = g++
+
 ifeq ($(DEBUG),1)
-export CXXFLAGS = -Wall -Wextra -DDEBUG -D_DEBUG -g -O0 -D_FILE_OFFSET_BITS=64 -fPIC $(INCLUDES)
+BT_CPPFLAGS = -DDEBUG -D_DEBUG -D_FILE_OFFSET_BITS=64 -DWITH_HTS_CB_API $(INCLUDES)
+BT_CXXFLAGS = -Wconversion -Wall -Wextra -g -O0
 else
-export CXXFLAGS = -Wall -O2 -D_FILE_OFFSET_BITS=64 -fPIC $(INCLUDES)
+BT_CPPFLAGS = -D_FILE_OFFSET_BITS=64 -DWITH_HTS_CB_API $(INCLUDES)
+BT_CXXFLAGS = -g -Wall -O2
 endif
 
 # If the user has specified to do so, tell the compile to use rand() (instead of mt19937).
 ifeq ($(USE_RAND),1)
-export CXXFLAGS += -DUSE_RAND
+BT_CXXFLAGS += -DUSE_RAND
 else
-export CXXFLAGS += -std=c++11
-endif 
-
-export LIBS		= -lz
-export BT_ROOT  = src/utils/BamTools/
+BT_CXXFLAGS += -std=c++11
+endif
+
+BT_LDFLAGS =
+BT_LIBS    = -lz -lm -lbz2 -llzma -lpthread
 
 prefix ?= /usr/local
 
@@ -75,6 +83,7 @@
 		  $(SRC_DIR)/spacingFile \
 		  $(SRC_DIR)/split \
 		  $(SRC_DIR)/subtractFile \
+		  $(SRC_DIR)/summaryFile \
 		  $(SRC_DIR)/tagBam \
 		  $(SRC_DIR)/unionBedGraphs \
 		  $(SRC_DIR)/windowBed \
@@ -97,7 +106,6 @@
 				$(SRC_DIR)/utils/NewChromsweep \
 				$(SRC_DIR)/utils/sequenceUtilities \
 				$(SRC_DIR)/utils/tabFile \
-				$(SRC_DIR)/utils/BamTools \
 				$(SRC_DIR)/utils/BamTools-Ancillary \
 				$(SRC_DIR)/utils/BlockedIntervals \
 				$(SRC_DIR)/utils/Fasta \
@@ -107,46 +115,73 @@
 				$(SRC_DIR)/utils/ToolBase \
 				$(SRC_DIR)/utils/driver
 
-BUILT_OBJECTS = $(OBJ_DIR)/*.o
-
-
-INCLUDES =	-I$(SRC_DIR)/utils/bedFile \
-				-I$(SRC_DIR)/utils/BinTree \
-				-I$(SRC_DIR)/utils/version \
-				-I$(SRC_DIR)/utils/bedGraphFile \
-				-I$(SRC_DIR)/utils/chromsweep \
-				-I$(SRC_DIR)/utils/Contexts \
-				-I$(SRC_DIR)/utils/FileRecordTools \
-				-I$(SRC_DIR)/utils/FileRecordTools/FileReaders \
-				-I$(SRC_DIR)/utils/FileRecordTools/Records \
-				-I$(SRC_DIR)/utils/general \
-				-I$(SRC_DIR)/utils/gzstream \
-				-I$(SRC_DIR)/utils/fileType \
-				-I$(SRC_DIR)/utils/gzstream/ \
+INCLUDES =		$(addprefix -I,$(SUBDIRS) $(UTIL_SUBDIRS)) \
+				-I$(SRC_DIR)/utils/BamTools/include \
+				-I$(HTSDIR) \
 				-I$(SRC_DIR)/utils/lineFileUtilities \
-				-I$(SRC_DIR)/utils/KeyListOps \
-				-I$(SRC_DIR)/utils/NewChromsweep \
-				-I$(SRC_DIR)/utils/sequenceUtilities \
-				-I$(SRC_DIR)/utils/tabFile \
-				-I$(SRC_DIR)/utils/BamTools \
-				-I$(SRC_DIR)/utils/BamTools/include \
-				-I$(SRC_DIR)/utils/BamTools/src \
-				-I$(SRC_DIR)/utils/BamTools-Ancillary \
-				-I$(SRC_DIR)/utils/BlockedIntervals \
-				-I$(SRC_DIR)/utils/Fasta \
-				-I$(SRC_DIR)/utils/VectorOps \
-				-I$(SRC_DIR)/utils/GenomeFile \
-				-I$(SRC_DIR)/utils/RecordOutputMgr \
-				-I$(SRC_DIR)/utils/ToolBase \
-				-I$(SRC_DIR)/utils/driver \
-
-
-all: print_banner $(OBJ_DIR) $(BIN_DIR) autoversion $(UTIL_SUBDIRS) $(SUBDIRS)
+				-I$(SRC_DIR)/utils/Point \
+				-I$(SRC_DIR)/utils/stringUtilities
+
+
+# Ensure that the user's $CXXFLAGS/etc are applied after bedtools's.
+ALL_CXXFLAGS = $(BT_CXXFLAGS) $(CXXFLAGS)
+ALL_CPPFLAGS = $(BT_CPPFLAGS) $(CPPFLAGS)
+ALL_LDFLAGS  = $(BT_LDFLAGS) $(LDFLAGS)
+ALL_LIBS     = $(BT_LIBS) $(LIBS)
+
+
+all: print_banner $(BIN_DIR)/bedtools $(BIN_DIR)/intersectBed
+
+static: print_banner $(BIN_DIR)/bedtools.static
+
+BUILT_OBJECTS = $(OBJ_DIR)/bedtools.o
+# Include all the Makefile fragments, which add to $(BUILT_OBJECTS)
+include $(patsubst %,%/Makefile.frag,$(SUBDIRS) $(UTIL_SUBDIRS))
+
+## Automatically generate C++ dependencies.
+## $(DEPFLAGS) is a set of compiler flags that causes the compiler to generate
+## dependencies as a byproduct (which we write to a temporary file, only moving
+## it into place on successful compilations).
+## We then include the dependency files into this Makefile.
+## The subdirectories' Makefile fragments contain rules like the one for
+## $(OBJ_DIR)/bedtools.o below, with a dependency on obj/foo.d so that if
+## the dependency file is missing the target will be rebuilt.
+##
+DEPFLAGS = -MT $@ -MMD -MP -MF $*.Td
+
+define CXX_COMPILE
+@echo "  * compiling $<"
+$(CCPREFIX) $(CC_WRAPPER) $(CXX) $(ALL_CXXFLAGS) $(ALL_CPPFLAGS) $(DEPFLAGS) -c -o $@ $<
+@mv -f $*.Td $*.d
+endef
+
+$(OBJ_DIR)/%.d: ;
+.PRECIOUS: $(OBJ_DIR)/%.d
+
+-include $(patsubst %.o,%.d,$(BUILT_OBJECTS))
+
+$(OBJ_DIR)/bedtools.o: $(SRC_DIR)/bedtools.cpp $(OBJ_DIR)/bedtools.d
+	$(CXX_COMPILE)
+
+# HTSlib's htslib.mk provides rules to rebuild $(HTSDIR)/libhts.a.
+HTSDIR = src/utils/htslib
+include $(HTSDIR)/htslib.mk
+
+# This order-only prerequisite ensures OBJ_DIR exists before building any .o file
+# but ignores the directory's timestamp, which changes every time a .o file is written.
+$(BUILT_OBJECTS): | $(OBJ_DIR)
+
+$(BIN_DIR)/bedtools: autoversion $(BUILT_OBJECTS) $(HTSDIR)/libhts.a | $(BIN_DIR)
 	@echo "- Building main bedtools binary."
-	@$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c src/bedtools.cpp -o obj/bedtools.o $(INCLUDES)
-	@$(CXX) $(CXXFLAGS) $(CPPFLAGS) -o $(BIN_DIR)/bedtools $(BUILT_OBJECTS) -L$(UTIL_DIR)/BamTools/lib/ -lbamtools $(LIBS) $(LDFLAGS) $(INCLUDES)
+	$(CCPREFIX) $(CC_WRAPPER) $(CXX) $(ALL_LDFLAGS) -o $(BIN_DIR)/bedtools $(BUILT_OBJECTS) $(HTSDIR)/libhts.a $(ALL_LIBS)
 	@echo "done."
 
+$(BIN_DIR)/bedtools.static: autoversion $(BUILT_OBJECTS) $(HTSDIR)/libhts.a | $(BIN_DIR)
+	@echo "- Building main bedtools binary."
+	$(CCPREFIX) $(CC_WRAPPER) $(CXX) -static $(ALL_LDFLAGS) -o $(BIN_DIR)/bedtools.static $(BUILT_OBJECTS) $(HTSDIR)/libhts.a $(ALL_LIBS)
+	@echo "done."
+
+$(BIN_DIR)/intersectBed: | $(BIN_DIR)
 	@echo "- Creating executables for old CLI."
 	@python scripts/makeBashScripts.py
 	@chmod +x bin/*
@@ -164,7 +199,7 @@
 print_banner:
 	@echo "Building BEDTools:"
 	@echo "========================================================="
-	$(info $$CXXFLAGS is [${CXXFLAGS}])
+	@echo "CXXFLAGS is [$(ALL_CXXFLAGS)]"
 .PHONY: print_banner
 
 # make the "obj/" and "bin/" directories, if they don't exist
@@ -172,24 +207,13 @@
 	@mkdir -p $@
 
 
-# One special case: All (or almost all) programs requires the BamTools API files to be created first.
-.PHONY: bamtools_api
-bamtools_api:
-	@$(MAKE) --no-print-directory --directory=$(BT_ROOT) api
-$(UTIL_SUBDIRS) $(SUBDIRS): bamtools_api
-
-
-# even though these are real directories, treat them as phony targets, forcing to always go in them are re-make.
-# a future improvement would be the check for the compiled object, and rebuild only if the source code is newer.
-.PHONY: $(UTIL_SUBDIRS) $(SUBDIRS)
-$(UTIL_SUBDIRS) $(SUBDIRS): $(OBJ_DIR) $(BIN_DIR)
-	@echo "- Building in $@"
-	@$(MAKE) --no-print-directory --directory=$@
-
+# Usually HTSlib's configure script has not been used (detected via config.mk
+# not existing), so clean should also remove the generated config.h.
 clean:
-	@$(MAKE) --no-print-directory --directory=$(BT_ROOT) clean_api
 	@echo " * Cleaning up."
 	@rm -f $(VERSION_FILE) $(OBJ_DIR)/* $(BIN_DIR)/*
+	@cd src/utils/htslib && make clean > /dev/null
+	@test -e src/utils/htslib/config.mk || rm -f src/utils/htslib/config.h
 .PHONY: clean
 
 test: all

=== debian/changelog ===
bedtools (2.29.2+dfsg-3build2) groovy; urgency=medium

  * No-change rebuild because 2.29.2+dfsg-3(build1) was published in Ubuntu
    before.

 -- Logan Rosen <logan@ubuntu.com>  Sat, 09 May 2020 17:12:23 -0400

bedtools (2.29.2+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Build on any architecture

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 14 Feb 2020 16:02:39 +0100

bedtools (2.29.2+dfsg-2) unstable; urgency=medium

  [ Steffen Moeller ]
  * Team upload.
  * Added version to dependency of samtools

  [ Michael R. Crusoe ]
  * Make the build verbose
  * Fix a spelling typo
  * Improve hardening & enable cross building

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 11 Feb 2020 16:30:06 +0100

bedtools (2.29.2+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Fixed failing intersect.new #78 test as instructed on
    https://github.com/arq5x/bedtools2/issues/814
  * Standard-Version: 4.5.0

 -- Steffen Moeller <moeller@debian.org>  Sat, 18 Jan 2020 01:44:47 +0100

bedtools (2.29.0+dfsg-2) unstable; urgency=medium

  * Fix Build-Depends (s/python/python3/) and replace remaining references
    to python by python3
    Closes: #936199
  * autopkgtest: s/ADTTMP/AUTOPKGTEST_TMP/g
  * Remove patches louder, reproducible_build.patch that are missing
    from debian/patches/series.
  * Set fields Upstream-Contact in debian/copyright.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata.

 -- Andreas Tille <tille@debian.org>  Thu, 05 Dec 2019 12:11:59 +0100

bedtools (2.29.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Removed Chris' reproducible builds patch - upstream diverged too much

 -- Steffen Moeller <moeller@debian.org>  Tue, 05 Nov 2019 21:41:22 +0100

bedtools (2.28.0+dfsg1-1) unstable; urgency=medium

  * Use 2to3 to port to Python3
    Closes: #936199
  * Remove unsafe links for gcc and g++

 -- Andreas Tille <tille@debian.org>  Sun, 01 Sep 2019 11:14:59 +0200

bedtools (2.28.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * And another new dependency on liblzma-dev

 -- Steffen Moeller <moeller@debian.org>  Fri, 26 Jul 2019 19:06:23 +0200

bedtools (2.28.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Debian CI kindly pointed me to a new build dependency
    on libbz2-dev (https://salsa.debian.org/med-team/bedtools/-/jobs/238984).

 -- Steffen Moeller <moeller@debian.org>  Fri, 26 Jul 2019 18:38:06 +0200

bedtools (2.28.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debhelper-compat 12
  * Standards-Version: 4.4.0

  * Semi-automated update with Andreas' routine-update script,
    only reintroduced the conflicts of the test package with earlier
    releases of bedtools.

 -- Steffen Moeller <moeller@debian.org>  Fri, 26 Jul 2019 17:33:35 +0200

=== debian/control ===
--- 
+++ 
@@ -4,19 +4,22 @@
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
-               python2,
+Build-Depends: debhelper-compat (= 12),
+               python3,
                zlib1g-dev,
-               samtools
-Standards-Version: 4.3.0
+               libbz2-dev,
+               liblzma-dev,
+               samtools (>= 1.10)
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/bedtools
 Vcs-Git: https://salsa.debian.org/med-team/bedtools.git
 Homepage: https://github.com/arq5x/bedtools2
 
 Package: bedtools
-Architecture: amd64 arm64 armel armhf i386 mips64el mipsel ppc64el
+Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
+Recommends: samtools (>= 1.10)
 Conflicts: filo
 Provides: filo
 Replaces: filo
@@ -34,8 +37,6 @@
 Multi-Arch: foreign
 Depends: ${misc:Depends}
 Suggests: bedtools
-Breaks: bedtools (<< 2.19.1-1)
-Replaces: bedtools (<< 2.19.1-1)
 Description: test data for the bedtools package
  Test data for the BEDTools suite of utilities for comparing genomic features.
  It is distributed in a separate package because it is large and

=== debian/rules ===
--- 
+++ 
@@ -12,8 +12,15 @@
 %:
 	dh $@
 
-override_dh_installchangelogs:
-	dh_installchangelogs RELEASE_HISTORY
+override_dh_auto_build:
+	dh_auto_build -- VERBOSE=1
+
+override_dh_auto_install:
+	dh_auto_install -- VERBOSE=1
+
+# File no longer exists
+#override_dh_installchangelogs:
+#	dh_installchangelogs RELEASE_HISTORY
 
 override_dh_install:
 	dh_install

## bedtools 2.30.0%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,26 @@
 Source: bedtools
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Charles Plessy <plessy@debian.org>,
-           Andreas Tille <tille@debian.org>
+           Andreas Tille <tille@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                python3,
                zlib1g-dev,
                libbz2-dev,
-               liblzma-dev,
-               samtools (>= 1.10)
-Standards-Version: 4.5.0
+               liblzma-dev
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/bedtools
 Vcs-Git: https://salsa.debian.org/med-team/bedtools.git
 Homepage: https://github.com/arq5x/bedtools2
+Rules-Requires-Root: no
 
 Package: bedtools
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
-Recommends: samtools (>= 1.10)
 Conflicts: filo
 Provides: filo
 Replaces: filo
